"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var expo_router_1 = require("expo-router");
var react_1 = __importDefault(require("react"));
var cover_1 = require("@/components/cover");
var ui_1 = require("@/components/ui");
var hooks_1 = require("@/lib/hooks");
function Onboarding() {
    var _a = (0, hooks_1.useIsFirstTime)(), _ = _a[0], setIsFirstTime = _a[1];
    var router = (0, expo_router_1.useRouter)();
    return (<ui_1.View className="flex h-full items-center  justify-center">
      <ui_1.FocusAwareStatusBar />
      <ui_1.View className="w-full flex-1">
        <cover_1.Cover />
      </ui_1.View>
      <ui_1.View className="justify-end ">
        <ui_1.Text className="my-3 text-center text-5xl font-bold">
          Obytes Starter
        </ui_1.Text>
        <ui_1.Text className="mb-2 text-center text-lg text-gray-600">
          The right way to build your mobile app
        </ui_1.Text>

        <ui_1.Text className="my-1 pt-6 text-left text-lg">
          🚀 Production-ready{' '}
        </ui_1.Text>
        <ui_1.Text className="my-1 text-left text-lg">
          🥷 Developer experience + Productivity
        </ui_1.Text>
        <ui_1.Text className="my-1 text-left text-lg">
          🧩 Minimal code and dependencies
        </ui_1.Text>
        <ui_1.Text className="my-1 text-left text-lg">
          💪 well maintained third-party libraries
        </ui_1.Text>
      </ui_1.View>
      <ui_1.SafeAreaView className="mt-6">
        <ui_1.Button label="Let's Get Started " onPress={function () {
            setIsFirstTime(false);
            router.replace('/login');
        }}/>
      </ui_1.SafeAreaView>
    </ui_1.View>);
}
exports.default = Onboarding;
//# sourceMappingURL=onboarding.js.map