"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var style_utils_1 = require("./style-utils");
var text_1 = __importDefault(require("./text"));
var BUTTON_PRESETS = {
    primary: {
        backgroundColor: 'emerald-500',
        textColor: 'white',
    },
    primaryLow: {
        backgroundColor: 'rgba(16, 185, 129, 0.1)',
        textColor: 'emerald-500',
    },
    secondary: {
        backgroundColor: 'gray-900',
        textColor: 'white',
    },
    secondaryLow: {
        backgroundColor: 'gray-100',
        textColor: 'gray-900',
    },
    outlined: {
        backgroundColor: 'white',
        textColor: 'gray-900',
    },
    danger: {
        backgroundColor: 'red-500',
        textColor: 'white',
    },
    dangerLow: {
        backgroundColor: 'rgba(239, 68, 68, 0.1)',
        textColor: 'red-500',
    },
};
function Button(_a) {
    var variant = _a.variant, _b = _a.loading, loading = _b === void 0 ? false : _b, _c = _a.text, text = _c === void 0 ? 'default' : _c, textColor = _a.textColor, backgroundColor = _a.backgroundColor, _d = _a.width, width = _d === void 0 ? 'w-full' : _d, _e = _a.height, height = _e === void 0 ? 'h-[56px]' : _e, shape = _a.shape, _f = _a.radius, radius = _f === void 0 ? 'rounded-2xl' : _f, _g = _a.disabled, disabled = _g === void 0 ? false : _g, _h = _a.border, border = _h === void 0 ? { borderWidth: '0', borderColor: 'transparent' } : _h, onPress = _a.onPress, leftIcon = _a.leftIcon, rightIcon = _a.rightIcon, className = _a.className, style = _a.style;
    var preset = variant ? BUTTON_PRESETS[variant] : null;
    var defaultStyles = {
        backgroundColor: (preset === null || preset === void 0 ? void 0 : preset.backgroundColor) || 'black',
        textColor: (preset === null || preset === void 0 ? void 0 : preset.textColor) || 'white',
        border: variant === 'outlined'
            ? { borderWidth: '1', borderColor: 'gray-300' }
            : { borderWidth: '0', borderColor: 'transparent' },
        width: 'w-full',
        height: 'h-14',
        radius: shape === 'pill' ? 'rounded-full' : 'rounded-2xl',
    };
    var finalStyles = {
        backgroundColor: backgroundColor || defaultStyles.backgroundColor,
        textColor: textColor || defaultStyles.textColor,
        border: variant === 'outlined'
            ? { borderWidth: '1', borderColor: 'gray-300' }
            : border || defaultStyles.border,
        width: width || defaultStyles.width,
        height: height || defaultStyles.height,
        radius: shape
            ? shape === 'pill'
                ? 'rounded-full'
                : 'rounded-2xl'
            : radius || defaultStyles.radius,
    };
    var getMarginStyle = function (gap, isLeft) {
        if (isLeft === void 0) { isLeft = true; }
        if (!gap)
            return {};
        if (typeof gap === 'number') {
            return isLeft ? { marginRight: gap } : { marginLeft: gap };
        }
        return { className: gap }; // string인 경우 className으로 반환
    };
    return (<react_native_1.TouchableOpacity activeOpacity={0.7} className={"\n        flex-row items-center justify-center\n        ".concat(finalStyles.width, " ").concat(finalStyles.height, " ").concat(finalStyles.radius, "\n        ").concat(disabled ? 'opacity-50' : '', "\n        ").concat(className || '', "  \n      ")} style={[
            {
                backgroundColor: (0, style_utils_1.getColor)(finalStyles.backgroundColor),
                borderWidth: Number(finalStyles.border.borderWidth),
                borderColor: (0, style_utils_1.getColor)(finalStyles.border.borderColor),
            },
            !className && style,
        ]} onPress={onPress} disabled={disabled || loading}>
      {loading ? (<react_native_1.ActivityIndicator size="small" color={(0, style_utils_1.getColor)(finalStyles.textColor)}/>) : (<react_native_1.View className="flex-row items-center justify-center">
          {leftIcon && (<react_native_1.View {...getMarginStyle(leftIcon.gap, true)}>{leftIcon.icon}</react_native_1.View>)}

          {/* <Text
              className="text-center font-medium"
              style={{ color: getColor(finalStyles.textColor) }}
            >
              {text}
            </Text> */}

          <text_1.default face="body" size="large" weight="semibold" className="px-[4px]" textColor={finalStyles.textColor}>
            {text}
          </text_1.default>

          {rightIcon && (<react_native_1.View {...getMarginStyle(rightIcon.gap, false)}>
              {rightIcon.icon}
            </react_native_1.View>)}
        </react_native_1.View>)}
    </react_native_1.TouchableOpacity>);
}
exports.default = Button;
//# sourceMappingURL=button.js.map