"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var style_utils_1 = require("./style-utils");
var input_clear_1 = require("./icons/input-clear");
var error_symbol_1 = require("./icons/error-symbol");
var clear_symbol_1 = require("./icons/clear-symbol");
var id_dash_1 = require("./icons/id-dash");
var able_eye_1 = require("./icons/able-eye");
var unable_eye_1 = require("./icons/unable-eye");
var react_1 = require("react");
var label_1 = __importDefault(require("./label"));
var text_1 = __importDefault(require("./text"));
function TextField(_a) {
    var label = _a.label, input = _a.input, _b = _a.statusConfig, statusConfig = _b === void 0 ? { status: 'none', message: '' } : _b, onClear = _a.onClear, onChangeText = _a.onChangeText;
    var _c = (0, react_1.useState)(false), isFocused = _c[0], setIsFocused = _c[1];
    var secondInputRef = React.useRef(null);
    var _d = input.mode, mode = _d === void 0 ? 'default' : _d, value = input.value, _e = input.placeholder, placeholder = _e === void 0 ? '' : _e, _f = input.textColor, textColor = _f === void 0 ? 'black' : _f, _g = input.placeholderColor, placeholderColor = _g === void 0 ? 'gray' : _g, _h = input.backgroundColor, backgroundColor = _h === void 0 ? 'white' : _h, _j = input.width, width = _j === void 0 ? 'w-full' : _j, _k = input.height, height = _k === void 0 ? 'h-[56px]' : _k, _l = input.radius, radius = _l === void 0 ? 'rounded-2xl' : _l, _m = input.border, border = _m === void 0 ? { borderWidth: '1', borderColor: 'gray' } : _m, textStyle = input.textStyle, className = input.className, style = input.style, _o = input.disabled, disabled = _o === void 0 ? false : _o, idValue = input.idValue, onIdChange = input.onIdChange, _p = input.isSecureTextEntry, isSecureTextEntry = _p === void 0 ? true : _p, onSecureTextEntryChange = input.onSecureTextEntryChange, _q = input.characterCount, characterCount = _q === void 0 ? false : _q, _r = input.maxCharacterCount, maxCharacterCount = _r === void 0 ? 0 : _r;
    var borderStyle = typeof border === 'string' ? border : '';
    var getStatusStyles = function () {
        if (statusConfig.status === 'none') {
            return isFocused
                ? { borderWidth: 1, borderColor: (0, style_utils_1.getColor)('gray-500') }
                : { borderWidth: 0, backgroundColor: (0, style_utils_1.getColor)('gray-100') };
        }
        var statusStyles = {
            error: {
                borderWidth: 2,
                borderColor: (0, style_utils_1.getColor)('red-500'),
                backgroundColor: 'rgba(239, 68, 68, 0.1)',
            },
            success: {
                borderWidth: 2,
                borderColor: (0, style_utils_1.getColor)('green-500'),
                backgroundColor: 'rgba(34, 197, 94, 0.1)',
            },
        };
        return statusStyles[statusConfig.status];
    };
    var getMessageClassName = function () {
        var defaultClasses = {
            error: 'text-red-500',
            success: 'text-green-500',
        };
        return statusConfig.status !== 'none'
            ? "".concat(defaultClasses[statusConfig.status], " ").concat(statusConfig.messageClassName || '')
            : '';
    };
    return (<react_native_1.View className="w-full">
      {label && (<react_native_1.View>
          <label_1.default value={label.text} labelClassName={"mb-2 ml-[4px] ".concat(label.className || 'text-sm text-gray-700')} style={label.style} isLabelOnly={true} required={label.required}/>
        </react_native_1.View>)}
      <react_native_1.View className={"\n          ".concat(width, " ").concat(height, " ").concat(radius, "\n          ").concat(disabled ? 'opacity-50' : '', "\n          ").concat(borderStyle, "\n          ").concat(className || '', "\n        ")} style={[
            __assign(__assign({ backgroundColor: (0, style_utils_1.getColor)(backgroundColor) }, (typeof border !== 'string' && {
                borderWidth: Number(border.borderWidth),
                borderColor: (0, style_utils_1.getColor)(border.borderColor),
            })), getStatusStyles()),
            !className && style,
        ]}>
        {mode === 'default' && (<react_native_1.View className="flex-row items-center h-full">
            <label_1.default value={value} placeholder={placeholder} onChangeText={onChangeText} onFocus={function () { return setIsFocused(true); }} onBlur={function () { return setIsFocused(false); }} className="flex-1 px-4 pr-12 h-full" textColor={textColor} placeholderColor={placeholderColor} textStyle={textStyle} disabled={disabled}/>
            {value && onClear && (<react_native_1.View className="absolute right-[10px] h-full flex-row items-center">
                <react_native_1.TouchableOpacity activeOpacity={1} className="h-full justify-center" onPress={onClear}>
                  <input_clear_1.InputClearIcon />
                </react_native_1.TouchableOpacity>
              </react_native_1.View>)}
          </react_native_1.View>)}

        {mode === 'password' && (<react_native_1.View className="flex-row items-center h-full">
            <label_1.default value={value} placeholder={placeholder} onChangeText={onChangeText} onFocus={function () { return setIsFocused(true); }} onBlur={function () { return setIsFocused(false); }} className="flex-1 px-4 pr-24 h-full" textColor={textColor} placeholderColor={placeholderColor} textStyle={textStyle} disabled={disabled} secureTextEntry={isSecureTextEntry}/>
            <react_native_1.View className="absolute right-[10px] h-full flex-row items-center">
              {value && onClear && (<react_native_1.TouchableOpacity activeOpacity={1} className="h-full justify-center " onPress={onClear}>
                  <input_clear_1.InputClearIcon />
                </react_native_1.TouchableOpacity>)}
              <react_native_1.TouchableOpacity activeOpacity={1} className="h-full justify-center" onPress={function () { return onSecureTextEntryChange === null || onSecureTextEntryChange === void 0 ? void 0 : onSecureTextEntryChange(!isSecureTextEntry); }}>
                {isSecureTextEntry ? <unable_eye_1.UnableEyeIcon /> : <able_eye_1.AbleEyeIcon />}
              </react_native_1.TouchableOpacity>
            </react_native_1.View>
          </react_native_1.View>)}

        {mode === 'id' && (<react_native_1.View className="flex-row items-center h-full">
            <react_native_1.View className="flex-row items-center flex-1">
              <label_1.default value={idValue === null || idValue === void 0 ? void 0 : idValue.first} maxLength={6} keyboardType="numeric" className="min-w-[50px] ml-4" textColor={textColor} textStyle={textStyle} disabled={disabled} onChangeText={function (text) {
                var _a;
                var numbers = text.replace(/[^0-9]/g, '');
                if (onIdChange === null || onIdChange === void 0 ? void 0 : onIdChange.onFirstChange) {
                    onIdChange.onFirstChange(numbers);
                    if (numbers.length === 6) {
                        (_a = secondInputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
                    }
                }
            }} onFocus={function () { return setIsFocused(true); }} onBlur={function () { return setIsFocused(false); }}/>
              <id_dash_1.IdDashIcon />
              <label_1.default ref={secondInputRef} value={idValue === null || idValue === void 0 ? void 0 : idValue.second} maxLength={1} keyboardType="numeric" className="min-w-[10px]" textColor={textColor} textStyle={textStyle} disabled={disabled} onChangeText={function (text) {
                var numbers = text.replace(/[^0-9]/g, '');
                if (onIdChange === null || onIdChange === void 0 ? void 0 : onIdChange.onSecondChange) {
                    onIdChange.onSecondChange(numbers);
                }
            }} onFocus={function () { return setIsFocused(true); }} onBlur={function () { return setIsFocused(false); }}/>
              <label_1.default value="000000" secureTextEntry={true} editable={false} className="w-[60px] text-center" textColor={textColor} textStyle={__assign(__assign({}, textStyle), { letterSpacing: 1.2 })}/>
            </react_native_1.View>
            {((idValue === null || idValue === void 0 ? void 0 : idValue.first) || (idValue === null || idValue === void 0 ? void 0 : idValue.second)) && onClear && (<react_native_1.View className="h-full flex-row items-center mr-[10px]">
                <react_native_1.TouchableOpacity activeOpacity={1} className="h-full justify-center" onPress={onClear}>
                  <input_clear_1.InputClearIcon />
                </react_native_1.TouchableOpacity>
              </react_native_1.View>)}
          </react_native_1.View>)}
      </react_native_1.View>
      {statusConfig.status !== 'none' && statusConfig.message && (<react_native_1.View className="flex-row items-center mt-2">
          {statusConfig.status === 'error' && (<error_symbol_1.ErrorSymbolIcon className="mr-1"/>)}
          {statusConfig.status === 'success' && (<clear_symbol_1.ClearSymbolIcon className="mr-1"/>)}
          {/* <Text
              className={getMessageClassName()}
              style={statusConfig.messageStyle}
            >
              {statusConfig.message}
            </Text> */}

          {statusConfig && statusConfig.message && (<text_1.default face={'body'} size="small" weight="regular" className={getMessageClassName()}>
              {statusConfig.message}
            </text_1.default>)}
        </react_native_1.View>)}
    </react_native_1.View>);
}
exports.default = TextField;
//# sourceMappingURL=textfield.js.map